#include <unistd.h>
#include <signal.h>
#include <stdlib.h>

void hook_signal(int signum, void (*fn)(int), int flags) {
  struct sigaction new_action;

  new_action.sa_handler = fn;
  sigemptyset(&new_action.sa_mask);
  new_action.sa_flags = flags;

  (void)sigaction(signum, &new_action, NULL);
}

void disable_signal(int signum) {
  struct sigaction new_action;

  new_action.sa_handler = SIG_IGN;
  sigemptyset(&new_action.sa_mask);

  (void)sigaction(signum, &new_action, NULL);
}

